/******************************************************************************
;  *       @ͺ                 : MC32F7361
;  *       @             : 2021.12.21
;  *       @˾/            : SINOMCU-FAE
;  *       @΢֧       : 2048615934
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2021 SINOMCU˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                ʱ1--PWM1
;  *                P16(FPWM1)P17(PWM1)ΣF=10k,D=25%,DT=4us
;  *                2SP16,P17ֹPWM,IO.
;  *                ʹPCK1(P04)PDT1(P15)                                          
******************************************************************************/

#include "user.h"

/************************************************
;  *    @          : CLR_RAM
;  *    @˵            : RAM
;  *    @        :
;  *    @ز        :
;  ***********************************************/
void CLR_RAM(void)
{
    for (FSR0 = 0; FSR0 < 0xff; FSR0++)
    {
        INDF0 = 0x00;
    }
    FSR0 = 0xFF;
    INDF0 = 0x00;
}
/************************************************
;  *    @            : IO_Init
;  *    @˵              : IOʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void IO_Init(void)
{
    //P00-P05 ,
    IOP0 = 0x00;                       //ioλ
    OEP0 = 0x3F;                       //ioڷ 1:out  0:in
    PUP0 = 0x00;                       //io   1:enable  0:disable
    PDP0 = 0x00;                       //io   1:enable  0:disable
    P0ADCR = 0x00;                     //ioѡ  1:ģ  0:ͨio
    //P10-P17 ,
    IOP1 = 0x00;                       //ioλ
    OEP1 = 0xFF;                       //ioڷ 1:out  0:in
    PUP1 = 0x00;                       //io   1:enable  0:disable
    PDP1 = 0x00;                       //io   1:enable  0:disable
    P1ADCR = 0x00;                     //ioѡ  1:ģ  0:ͨio
    //P20-P23 ,
    IOP2 = 0x00;                       //ioλ
    OEP2 = 0x0F;                       //ioڷ 1:out  0:in
    PUP2 = 0x00;                       //io   1:enable  0:disable
    PDP2 = 0x00;                       //io   1:enable  0:disablea

    PMOD = 0x00;                       //P00P01P13 io˿ֵӼĴ
    DRVCR = 0x80;                      //ͨ
}
/************************************************
;  *    @            : TIMER1_PWM_Init
;  *    @˵              : ʱ1,PWMʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void TIMER1_PWM_Init(void)
{
    T1CR = DEF_SET_BIT6 | DEF_SET_BIT1 | DEF_SET_BIT0;                    //ʹPWM,CPU=32M/4,8Ƶ,1MHz
    T1CNT = 100-1;
    T1LOAD = 100-1;                                                       //100us
    T1DATA = 25;
    PWMCR0 = DEF_SET_BIT7 | DEF_SET_BIT3 | DEF_SET_BIT2 | DEF_SET_BIT0;   //ʹFPWM4ʱ
    PWMCR1 = 0x00;                                                        //ͨģʽ
    T1EN = 1;
    T1IE = 1;
}
/************************************************
;  *    @            : Sys_Init
;  *    @˵              : ϵͳʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void Sys_Init(void)
{
    GIE = 0;
    CLR_RAM();
    IO_Init();

    TIMER1_PWM_Init();
    GIE = 1;
}
uint8_t count_2s;
/************************************************
;  *    @            : main
;  *    @˵              : 
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void main(void)
{
    Sys_Init();
    while (1)
    {
        if(TIMER_10MS_Flag) 
        {
   	   	   	TIMER_10MS_Flag =0;
            count_2s++;
   	   	}
        if(count_2s >=200)             // unit:10ms
        {
            count_2s =0;
            T1CR &= ~DEF_SET_BIT6 ;    // رPWM1
   	   	   	PWMCR0 = 0;                // ֹ˿FPWM1źŲ,ֶر,رPWM1FPWM1״̬
            P14D = 1;
            T1EN = 0;
        }
    }
}
uint8_t count_10ms;
/************************************************
;  *    @            : interrupt
;  *    @˵              : жϺ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void int_isr(void) __interrupt
{
__asm 
    movra _abuf
    swapar _PFLAG
    movra _statusbuf
__endasm;
   	if(T1IF & T1IE) 
    {
   	   	T1IF = 0;
   	   	count_10ms++;
   	   	if(count_10ms ==100)           // unit 100us
        {     
            count_10ms = 0;
            TIMER_10MS_Flag =1;
        }
   	}  
__asm 
    swapar _statusbuf
    movra _PFLAG
    swapr _abuf
    swapar _abuf
__endasm;
}

/**************************** end of file *********************************************/
